/*
 * Um dieses Programm mit Ihrem C-Compiler
 * bersetzen zu knnen, bentigen Sie die
 * entpsprechenden Include-Dateien und eine neue
 * amiga.lib. Diese erhalten Sie bei dem fr
 * Ihren Compiler zustndigen Hndler.
 */

#include <exec/types.h>
#include <exec/libraries.h>
#include <libraries/locale.h>

#include <clib/exec_protos.h>
#include <clib/dos_protos.h>

#include <pragmas/exec_pragmas.h>
#include <pragmas/dos_pragmas.h>

extern struct Library   *DOSBase;
extern struct Library   *SysBase;

struct Library *LocaleBase=NULL;
struct Locale *locale;

/*
 * protos
 */
struct Locale *OpenLocale(STRPTR);
STRPTR GetLocaleStr( struct Locale *, ULONG );
STRPTR GetCatalogStr(struct Catalog *, LONG, STRPTR );
BOOL   CloseLocale( struct Locale * );

VOID main(ULONG argc, char **argv)
{
  ULONG stringid;

  if( argc ) {
    /*
     * Nur vom CLI zu starten
     */
    LocaleBase=OpenLibrary("locale.library",38);

    if( LocaleBase ) {
      locale=OpenLocale(NULL);

      if( locale ) {
        for( stringid=1; stringid <= 50; stringid++ )
          printf("String[%d]=\"%s\"\n",stringid,GetLocaleStr(locale,stringid) );
        CloseLocale( locale );
      } else printf("Fehler beim ffnen der Locale\n");

      CloseLibrary(LocaleBase);
    } else printf("Locale.library konnte nicht geffnet\n");
  }
}
